Index: /trunk/scripts/README
===================================================================
--- /trunk/scripts/README	(revision 584)
+++ /trunk/scripts/README	(revision 1)
@@ -1,5 +1,5 @@
 
 
-This directory contains miscellaneous useful scripts, some of them contributed
+This directory contains miscellaneous useful scripts, mostly contributed
 by various users. Additions and/or improvements are welcome. 
 
@@ -28,14 +28,19 @@
    and database files.
 
-   Run 'samhainadmin.pl -h' for usage instructions.
+   Run 'samhainadmin.pl -h' for usage instaructions.
 
-yuleadmin.pl
-------------
+samhainrc_update.sh
+-------------------
 
-   Perl script (by Riccardo Murri) to list, add, and remove clients 
-   from the yulerc file.
+   If you are using the --with-kcheck option on Linux, after a kernel
+   update you need to change some option (addresses of kernel functions)
+   in the samhainrc configuration file. The correct new addresses must
+   be looked up in the System.map file
 
-   Run 'yuleadmin.pl -h' for usage instructions.
-
+   This script will do this automatically. Run 'samhainrc_update.sh -h'
+   for usage instructions. You may need to change the location of the
+   samhainrc file by editing the line 'SAMHAIN_CFG="/etc/samhainrc"'
+   at the beginning of the script.
+ 
 check_samhain.pl
 ----------------
@@ -97,3 +102,24 @@
 
 
+samhain-scripts/   Administrative scripts by 
+----------------   Simon Bailey <simon.bailey@uibk.ac.at> and
+                   Michael Redinger <michael.redinger@uibk.ac.at>
+
+		   You may need to adjust some of the variables in the
+		   top lines of these scripts.
+                
+   samhain.table.rotate.pl: Move old entries from mysql log table to a
+   			    backup table
+
+   samhain-admin: Interactive script to (1) clear log entries in SQL database,
+   		  (2) re-initialize file database of remote client, or (3) add
+		  a new host.
+		  This script requires that you are using samhains deploy
+		  system (i.e. the deploy.sh script et al.).
+		  Re-initialize will stop the daemon on the remote host,
+		  create a temp dir for the database, run samhain -t init,
+		  copy the database to the server, and clear the mysql log for
+		  this host.
+		  
+   samhain.clearhost: Helper script for samhain-admin.
 		   
Index: /trunk/scripts/check_samhain.pl.in
===================================================================
--- /trunk/scripts/check_samhain.pl.in	(revision 584)
+++ /trunk/scripts/check_samhain.pl.in	(revision 1)
@@ -4,5 +4,5 @@
 #   by the samhain file integrity checker.
 #
-# Copyright Rainer Wichmann (2004, 2012)
+# Copyright Rainer Wichmann (2004)
 #
 # License Information:
@@ -28,5 +28,5 @@
 use Getopt::Long;
 use vars qw($PROGNAME $SAMHAIN $opt_V $opt_h $opt_v $verbose $opt_w $opt_c $opt_t $status $msg $state $retval);
-use lib  "/usr/local/nagios/libexec" ;
+use lib  utils.pm;
 use utils qw(%ERRORS &print_revision);
 
@@ -49,5 +49,5 @@
 # -----------------------------------------------------------------[ Global ]--
 
-$PROGNAME = "check_@install_name@";
+$PROGNAME = "check_samhain";
 $SAMHAIN = "@sbindir@/@install_name@"; 
 
@@ -99,5 +99,5 @@
     $state = $ERRORS{'WARNING'};
 } else {
-    $msg = "CRITICAL: $status policy violations (threshold c=$opt_c)";
+    $msg = "CRITICAL: $status policy violations (threshold w=$opt_w)";
     $state = $ERRORS{'CRITICAL'};
 }
@@ -143,5 +143,5 @@
     
     if ($opt_V) {
-	print_revision($PROGNAME,'$Revision: 1.1 $ ');
+	print_revision($PROGNAME,'$Revision: 1.0 $ ');
 	exit $ERRORS{'OK'};
     }
@@ -182,6 +182,6 @@
 
 sub print_help () {
-    print_revision($PROGNAME, '1.1');
-    print "Copyright (c) 2004,2012 Rainer Wichmann
+    print_revision($PROGNAME, '$Revision: 1.0 $');
+    print "Copyright (c) 2004 Rainer Wichmann
 
 This plugin checks the number of policy violations reported by the
Index: /trunk/scripts/makeself/makeself.sh
===================================================================
--- /trunk/scripts/makeself/makeself.sh	(revision 584)
+++ /trunk/scripts/makeself/makeself.sh	(revision 1)
@@ -293,6 +293,5 @@
 echo Adding files to archive named \"$archname\"...
 (cd "$archdir"; tar $TAR_ARGS - * | eval "$GZIP_CMD" ) >> "$tmpfile" || { echo Aborting; rm -f "$tmpfile"; exit 1; }
-# The following command seems both superfluous and causing an 'I/O error' message
-# echo >> "$tmpfile" >&- # try to close the archive
+echo >> "$tmpfile" >&- # try to close the archive
 
 fsize=`cat "$tmpfile" | wc -c | tr -d " "`
Index: /trunk/scripts/redhat_i386.client.spec.in
===================================================================
--- /trunk/scripts/redhat_i386.client.spec.in	(revision 584)
+++ /trunk/scripts/redhat_i386.client.spec.in	(revision 1)
@@ -78,6 +78,6 @@
 # after the package is installed
 install -m 700 samhain-install.sh init/samhain.startLinux init/samhain.startLSB ${RPM_BUILD_ROOT}/etc
-install -m 640 -o 0 -g 0 samhain_kmem.ko	${RPM_BUILD_ROOT}/lib/modules/`uname -r`/samhain_kmem.ko
-install -m 640 -o 0 -g 0 samhain_hide.ko        ${RPM_BUILD_ROOT}/lib/modules/`uname -r`/samhain_hide.ko
+install -m 640 -o 0 -g 0 samhain_hide.o		${RPM_BUILD_ROOT}/lib/modules/`uname -r`/samhain_hide.o
+install -m 640 -o 0 -g 0 samhain_erase.o	${RPM_BUILD_ROOT}/lib/modules/`uname -r`/samhain_erase.o
 install -m 700 -o 0 -g 0 samhain_setpwd		${RPM_BUILD_ROOT}/usr/local/sbin/samhain_setpwd
 
@@ -123,4 +123,10 @@
 fi
 
+%postun
+if [ "$1" = 0 ]; then
+        # remove any kernel modules that might have been installed
+        RVER=`uname -r`
+        rm -f /lib/modules/$RVER/samhain*
+fi
 
 
@@ -129,11 +135,10 @@
 %dir /var/run
 %dir /var/log
-#%doc docs/BUGS COPYING docs/Changelog 
-#%doc LICENSE docs/HOWTO* docs/MANUAL-2_4.* docs/README*
+#%doc docs/BUGS COPYING docs/Changelog docs/TODO
+#%doc LICENSE docs/HOWTO* docs/MANUAL-2_0.* docs/README*
 /etc
 /usr/local/sbin/samhain
 /usr/local/sbin/samhain_setpwd
 /lib/modules
-%attr(644,root,root) /etc/logrotate.d/@install_name@
 #%attr(644,root,root) /usr/local/man/man5/samhain*
 #%attr(644,root,root) /usr/local/man/man8/samhain*
Index: /trunk/scripts/report.pl
===================================================================
--- /trunk/scripts/report.pl	(revision 1)
+++ /trunk/scripts/report.pl	(revision 1)
@@ -0,0 +1,239 @@
+#! /usr/bin/perl
+
+
+#
+
+# This tool will help extract the XML log file produced by Samhain
+# Put it into a more readable format that can then be run by CRON
+# and e-mailed to a user.
+#
+# Created: Ben <ben@deephouse.co.za>
+#
+#
+# Updates:
+# JUL 05 ver 1.1: - Updata to add in checkpint subroutine, this checks 
+#                   the scalar length
+#                   that is return from the log file if is is a good size
+#                   the program gets the value, if not value is returned it will not print it
+#                   to the report.
+#
+# JUL 07 ver 1.2: - Update to the Code to handle reporting selection 
+#                   from the command line.
+#                   Users are able to pass in [ReadOnly][LogFiles][Attributes].
+#                   Better support for date
+#
+# Version: 1.2
+
+
+
+
+
+use strict;
+
+use XML::Simple;
+
+use Tie::File;
+
+use POSIX qw(strftime);
+
+my $date=strftime("%a %b %d %H:%M:%S %Y", localtime());
+
+my $tdate = `date +'%m%d%y'`;   # Just to time stamp the files
+
+my $hostname = `hostname`; chomp($hostname);
+
+my $policy = $ARGV[1];
+
+
+
+&main();
+
+
+
+sub main {
+
+
+
+       unless (@ARGV == 2) { printf("Usage: $0 Samhain_report.xml <policyname. ReadOnly> \n"); exit(0); }
+
+        printf("## Reporting Starting\n");
+
+        &eatfile();
+
+        &extractdata($policy);
+
+        printf("## Report completed\n");
+
+        printf("## Your new report file has been created : Samhain-report-$hostname.$tdate\n");
+
+}
+
+
+
+# This routine will pull the data from the XML file, and sort through it
+
+# and look for the policy for [ReadOnly], once it has bfound that it will detected all the changes
+
+# within the policy
+
+#
+
+sub extractdata {
+
+   my $xmlfile = $ARGV[0];
+
+   my $config = XMLin($xmlfile);
+
+   # Create new report file
+
+   open(RP, ">fmre_report-$hostname.$tdate") || die ("Unable to open new report file, $!\n");
+
+    printf RP ("Samhain CRITICAL REPORT FOR $hostname\n");
+
+    printf RP ("\n");
+
+    printf RP ("This report was created on : $date\n");
+
+    printf RP ("Samhain Reporting Tool version 1.0\n");
+
+    printf RP ("Created: Ben Cuthbert <benjamin.cuthbert\@db.com>\n");
+
+    printf RP ("\n");
+
+    printf RP ("Report for !! $_[0] Policy !!\n");
+
+    printf RP ("\n");
+
+    # STart getting all of the data from xml file
+
+   foreach my $alert (@{$config->{'LOG'}}) {
+
+         if($alert->{msg} =~ /POLICY \[$_[0]]/) {       # Check we are on the correct policy
+
+          print RP ("File Changed: $alert->{path}\n");
+
+          &checkprint("$alert->{mtime_new}","Time Changed Old:   $alert->{mtime_new}");
+
+          &checkprint("$alert->{mtime_new}","Time Changed New:   $alert->{mtime_old}");
+
+          &checkprint("$alert->{mode_old}","Mode Old:   $alert->{mode_old}");
+
+          &checkprint("$alert->{mode_new}","Mode New:   $alert->{mode_new}");
+
+          &checkprint("$alert->{chksum_old}","CheckSum Old:     $alert->{chksum_old}");
+
+          &checkprint("$alert->{chksum_new}","CheckSum New:     $alert->{chksum_new}");
+
+          &checkprint("$alert->{size_new}","Size New:     $alert->{size_new}");
+
+          &checkprint("$alert->{size_old}","Size Old:     $alert->{size_old}");
+
+          printf RP ("\n");
+
+         }
+
+   }
+
+   printf RP ("Created Using: Samhain XML Reporting tool.\n");
+
+   printf RP ("Created By: Ben Cuthbert ben\@deephouse.co.za.\n");
+
+   close(RP);
+
+}
+
+
+
+# This helps with logs that do not have Entires for Certain modes ie --rwx
+
+# Get the scalar back, check the lenght then print out if the lenght is
+
+# bigger than 1
+
+sub checkprint {
+
+        chomp;
+
+        my $l = length($_[0]);
+
+        if($l gt 1) {
+
+                printf RP ("$_[1]\n");
+
+        }
+
+}
+
+# We need to change the structure of the HRML file from FMRE
+
+# so that we have the following tree structure.
+
+#VAR1 = {
+
+#        'LOG' => [
+
+#                  {
+
+#                       'msg' = 'value'
+
+#
+
+# The reason for this is it makes extraction better.
+
+#
+
+# So we open XML file and enter the following details.
+
+# <config> please at top of file
+
+# </config> place at bottom of file
+
+# </trail><trail> remove trails, as we do not require them as
+
+# log files are rotated every day.
+
+# reports will only run on the day.
+
+sub eatfile {
+
+        # Search and reaplce log with LOG, makes it easy
+
+        open(FH, "$ARGV[0]") || die ("Unable to ammend file \n");
+
+        open(FW, ">tmp.xml") || die ("Unable to ammend file \n");
+
+        while (<FH>) {
+
+         $_ =~ s/^---*//g; $_ =~ s/log/LOG/g; $_ =~ s/<trail>//g; $_ =~ s/<\/trail>//g; $_ =~ s/Log file printed//g;
+
+         printf FW $_;
+
+        }
+
+        close(FW); close(FH); system("mv tmp.xml $ARGV[0]");
+
+        # Put in <config> & </config> at top and bottom
+
+        open(FH, ">>$ARGV[0]") || die ("Unable to ammend file \n");
+
+        seek FH,0,2;
+
+        printf FH "</config>";
+
+        close(FH);
+
+        ## Star the insert at the top and bottom, close the config </config>
+
+        tie(my @FH1, 'Tie::File', $ARGV[0]) or die("Unable to read file, $!\n");
+
+        unshift @FH1, '<config>';
+
+        untie @FH1;
+
+        printf ("Xml file has been modified to run with this program \n");
+
+}
+
+
+
+
Index: /trunk/scripts/samhain-scripts/samhain-admin
===================================================================
--- /trunk/scripts/samhain-scripts/samhain-admin	(revision 1)
+++ /trunk/scripts/samhain-scripts/samhain-admin	(revision 1)
@@ -0,0 +1,398 @@
+#!/bin/sh
+
+YULERC="/etc/yulerc"
+YULEDIR="/var/lib/yule"
+YULELOG="/var/log/yule/yule_log"
+YULEUSER="yule"
+YULEGROUP="yule"
+YULERESTART="/sbin/service yule restart"
+
+deploybin="/usr/local/sbin/deploy.sh"
+
+# this is used for creating hosts only
+# (to check if this is a valid host)
+# if you uncomment it, this check will not be performed
+FORCEDOMAIN="yourdomain.net"
+
+action_dbclear="/usr/local/sbin/samhain.clearhost"
+
+
+geth() {
+	unset HLIST
+	unset FQHLIST
+	
+	for file in $(ls ${YULEDIR}/file* | egrep -v ".bak$" | egrep -v ".log$" | \
+		egrep -v ".mgmt$" | egrep -v ".old$" | egrep -v ".sav$" ) ;  do
+		# strip path
+		fn=$(basename ${file})
+		# strip leading "file."
+		fqhn=${fn#file.}
+		# strip trailing domain
+		hn=${fqhn%%.*}
+		# write results to two arrays
+		FQHLIST[${#FQHLIST[*]}]=$fqhn
+		HLIST[${#HLIST[*]}]=$hn
+	done
+	
+	# get the length of the two arrays
+	hlistlen=${#HLIST[*]}
+	fqhlistlen=${#FQHLIST[*]}
+
+	# run until a valid selection is made
+	while [ 1 ] ; do
+		clear
+		echo "HOST LIST SELECTION"
+		echo
+		
+		# loop through array, print echo each host
+		arrpos=0
+		while [ ${arrpos} -lt ${hlistlen} ] ; do
+			echo -e "$((${arrpos}+1)).\t${HLIST[${arrpos}]}"
+			arrpos=$((${arrpos}+1))
+		done
+		
+		echo
+		echo -n "Please select a host (q to quit): "
+		 
+		read hostsel
+		
+		if [ "${hostsel}" = "q" ] ; then
+			exit
+		fi
+
+		isnum=$(echo ${hostsel} | egrep "^[[:digit:]]*$")
+		if [ "${isnum}" ] ; then
+			if [ ${hostsel} -gt 0 -a ${hostsel} -lt $((${hlistlen}+1)) ]
+			then
+				hostsel=$((${hostsel}-1))
+				break
+			fi
+		fi
+	done
+}
+
+
+getprof() {
+	unset PLIST
+	for entry in $(find ${YULEDIR}/profiles -type d -maxdepth 1) ; do
+		entry=$(basename ${entry})
+		if [ ! "${entry}" = "src" -a ! "${entry}" = "profiles" ] ; then
+			PLIST[${#PLIST[*]}]=${entry}
+		fi
+	done
+	
+	# array length
+	plistlen=${#PLIST[*]}
+}
+
+
+
+
+cleardb() {
+# clear the SQL database
+	geth
+	(
+		echo "Clearing database for ${HLIST[${hostsel}]}:"
+		${action_dbclear} ${HLIST[${hostsel}]} 2>&1 && \
+			echo "exit 0"
+	) | less
+} 
+
+
+
+# re-init part
+rrinit() {
+
+	geth
+
+	if [ ! -f ${YULEDIR}/file.${FQHLIST[${hostsel}]} ] ;  then
+		echo "File ${YULEDIR}/file.${FQHLIST[${hostsel}]} does not exist. Exiting."
+		exit 42
+	fi
+
+	if [ ! -f ${YULEDIR}/rc.${FQHLIST[${hostsel}]} ] ;  then
+		echo "File ${YULEDIR}/rc.${FQHLIST[${hostsel}]} does not exist. Exiting."
+		exit 42
+	fi
+
+	echo "Please see the yule log if you really want to reinit the samhain database."
+	echo "This is a really ugly XML file. Better get out of here ..."
+	echo -n "Press ENTER to continue. "
+	read forgetthisone
+
+
+	while [ 1 ] ; do
+		grep "remote_host=\"${HLIST[${hostsel}]}\"" ${YULELOG} | less
+	
+		echo -n "Now that you've seen this: do you still want to continue? (y) (q to quit): "
+		read goforit
+
+		if [ "${goforit}" = "q" ] ; then
+			exit
+		fi
+
+		if [ "${goforit}" = "y" ] ; then
+			break
+		fi
+	done
+
+
+	# Clean the database
+	echo "Clearing database for ${HLIST[${hostsel}]}:"
+	${action_dbclear} ${HLIST[${hostsel}]} 2>&1 && echo "exit 0"
+
+
+	# now run remotely
+	# this code is _really_ funny ... :)
+	ssh -x root@${FQHLIST[${hostsel}]} \
+	'if [ ! -d /samhain-deploy ] ; then \
+	        mkdir /samhain-deploy ; \
+	fi ; \
+	if [ -f /samhain-deploy/sh_database ] ; then \
+		rm -f /samhain-deploy/sh_database ; \
+	fi ; \
+	if [ -x /usr/bin/monit -a "$(/usr/bin/monit status | grep samhain)" ] ; then \
+	        monit stop samhain && sleep 5 ; \
+	elif [ -x /etc/init.d/samhain ] ; then \
+	        /etc/init.d/samhain stop ; \
+	elif [ -x /etc/rc.d/init.d/samhain ] ; then \
+	        /etc/rc.d/init.d/samhain stop ;
+	else \
+		kill $(cat /var/run/samhain.pid) ; \
+	fi ; \
+	/sbin/samhain -t init '
+	echo -n -e '\a' ; sleep 1
+	echo -n -e '\a' ; sleep 1
+	echo -n -e '\a' ; sleep 1
+	echo -n -e '\a' ; sleep 1
+	echo -n -e '\a'
+
+	# backup old database
+	cp ${YULEDIR}/file.${FQHLIST[${hostsel}]} ${YULEDIR}/file.${FQHLIST[${hostsel}]}.mgmt
+
+	# get the new database
+	scp root@${FQHLIST[${hostsel}]}:/samhain-deploy/sh_database \
+		${YULEDIR}/file.${FQHLIST[${hostsel}]} && \
+	chown  ${YULEUSER}:${YULEGROUP} ${YULEDIR}/file.${FQHLIST[${hostsel}]} && \
+	chmod 600 ${YULEDIR}/file.${FQHLIST[${hostsel}]}
+	echo -n -e '\a' ; sleep 1
+	echo -n -e '\a' ; sleep 1
+	echo -n -e '\a' ; sleep 1
+	echo -n -e '\a' ; sleep 1
+	echo -n -e '\a'
+
+	while [ 1 ] ; do
+		echo
+		echo -n "Do you want to start the remote samhain client now? (y/n/q) "
+		read remotestart
+		
+		if [ "${remotestart}" = "q" ] ; then
+			exit
+		fi		
+
+		if [ "${remotestart}" = "y" -o "${remotestart}" = "n" ] ; then
+			break
+		fi
+	done
+
+	if [ "${remotestart}" = "y" ] ; then
+		# restart samhain on remote host
+		ssh -x root@${FQHLIST[${hostsel}]} \
+	        'if [ -f /samhain-deploy/sh_database ] ; then \
+	                rm -f /samhain-deploy/sh_database ; \
+	        fi ; \
+		if [ -x /usr/bin/monit -a "$(/usr/bin/monit status | grep samhain)" ] ; then \
+	        monit start samhain ; \
+		elif [ -x /etc/init.d/samhain ] ; then \
+		        /etc/init.d/samhain start ; \
+		elif [ -x /etc/rc.d/init.d/samhain ] ; then \
+		        /etc/rc.d/init.d/samhain start ;
+		else \
+		        echo "Do not know how to start samhain." ; \
+		fi'
+		echo -n -e '\a' ; sleep 1
+		echo -n -e '\a' ; sleep 1
+		echo -n -e '\a' ; sleep 1
+       		echo -n -e '\a' ; sleep 1
+		echo -n -e '\a'
+		
+		echo "done"
+	fi
+}
+
+
+# add a new host
+addnewhost() {
+	getprof
+
+	while [ 1 ] ; do
+	        clear
+	        echo "PROFILE SELECTION"
+	        echo
+	        
+	        # loop through array, print echo each host
+	        arrpos=0
+	        while [ ${arrpos} -lt ${plistlen} ] ; do
+	                echo -e "$((${arrpos}+1)).\t${PLIST[${arrpos}]}"
+	                arrpos=$((${arrpos}+1))
+	        done
+	        
+	        echo
+	        echo -n "Please select a profile (q to quit): "
+	
+	        read psel
+	
+	        if [ "${psel}" = "p" ] ; then
+	                exit
+	        fi
+	
+		if [ ${psel} -gt 0 -a ${psel} -lt $((${plistlen}+1)) ] ; then
+                	psel=$((${psel}-1))
+                	break
+		fi
+	done
+
+	while [ 1 ] ; do
+		echo
+		echo -n "Enter a fully qualified host name: "
+		read newhost
+		foundpoint=$(echo ${newhost} | egrep "\.")
+		if [ "${foundpoint}" ] ; then
+			break
+		else
+			echo "Dude, a FQHN please!"
+			continue
+		fi
+		if [ "${FORCEDOMAIN}" ] ; then
+			if [ "$(echo ${newhost} | egrep \"\.${FORCEDOMAIN}$\")" ] ; then
+				break
+			else
+				echo "Host must be in domain ${FORCEDOMAIN}"
+				continue
+			fi
+		fi
+	done
+
+
+	while [ 1 ] ; do
+		echo "You are going to run the following command:"
+		echo "${deploybin} --remote-host=${newhost} --build-OS=${PLIST[${psel}]} --clients=${YULERC}"
+		echo -n "Continue? (y/n/q) "
+		read pconf
+
+		if [ "${pconf}" = "q" ] ; then
+			exit
+		fi
+
+		if [ "${pconf}" = "y" -o "${pconf}" = "n" ] ; then
+			break
+		fi
+	done
+
+	if [ ${pconf} = "y" ] ; then
+		${deploybin} --remote-host=${newhost} --build-OS=${PLIST[${psel}]} --clients=${YULERC}
+
+
+		chown ${YULEUSER}:${YULEGROUP} ${YULEDIR}/file.${newhost} ${YULEDIR}/rc.${newhost}
+
+		while [ 1 ] ; do
+			echo
+			echo "Yule has to be restarted before the client is started."
+			echo -n "Do you want to restart yule now? (y|n) "
+			read yulerestart
+	
+			if [ "${yulerestart}" = "y" -o "${yulerestart}" = "n" ] ; then
+				break
+			fi
+		done
+	
+		if [ "${yulerestart}" = "y" ] ; then
+			eval ${YULERESTART}
+		fi
+
+
+		while [ 1 ] ; do
+			echo
+			echo -n "Do you want to start the remote samhain client now? (y|n) "
+			read startsam
+			if [ "${startsam}" = "y" -o "${startsam}" = "n" ] ; then
+	                        break
+	                fi
+		done
+
+
+		if [ "${startsam}" = "y" ] ; then
+
+			echo "x${newhost}x"
+
+			ssh -x root@${newhost} \
+			'if [ -f /var/run/samhain.pid ] ; then \
+				if [ -x /usr/bin/monit -a "$(/usr/bin/monit status | grep samhain)" ] ; then \
+					monit stop samhain && sleep 5 ; \
+				elif [ -x /etc/init.d/samhain ] ; then \
+					/etc/init.d/samhain stop ; \
+				elif [ -x /etc/rc.d/init.d/samhain ] ; then \
+					/etc/rc.d/init.d/samhain stop ;
+				else \
+					kill $(cat /var/run/samhain.pid) ; \
+				fi ; \
+			fi ; \
+			if [ -x /usr/bin/monit -a "$(/usr/bin/monit status | grep samhain)" ] ; then \
+				monit start samhain ; \
+			elif [ -x /etc/init.d/samhain ] ; then \
+				/etc/init.d/samhain start ; \
+			elif [ -x /etc/rc.d/init.d/samhain ] ; then \
+				/etc/rc.d/init.d/samhain start ;
+			else \
+				echo "Do not know how to start samhain." ; \
+			fi'
+	                echo -n -e '\a' ; sleep 1
+	                echo -n -e '\a' ; sleep 1
+	                echo -n -e '\a' ; sleep 1
+	                echo -n -e '\a' ; sleep 1
+	                echo -n -e '\a'
+	        fi
+	fi
+
+
+}
+
+
+
+
+# run until a valid selection is made
+while [ 1 ] ; do
+	clear
+	
+	echo "SELECT ACTION"
+	echo
+	
+	echo -e "1.\tOnly clear log entries in SQL database"
+	echo -e "2.\tReinitialize host database"
+	echo -e "3.\tAdd a new host"
+	echo
+	echo -n "Select an action (q to quit): "
+	
+	read action
+	
+	if [ "${action}" = "q" ] ; then
+                exit
+        fi
+
+	if [ "${action}" = "1" ] ; then
+		cleardb
+	fi
+
+	if [ "${action}" = "2" ] ; then
+		rrinit
+	fi
+
+	if [ "${action}" = "3" ] ; then
+		addnewhost
+	fi
+
+done
+
+
+
+
Index: /trunk/scripts/samhain-scripts/samhain.clearhost
===================================================================
--- /trunk/scripts/samhain-scripts/samhain.clearhost	(revision 1)
+++ /trunk/scripts/samhain-scripts/samhain.clearhost	(revision 1)
@@ -0,0 +1,21 @@
+#!/bin/sh
+
+[[ ${#} = 1 ]] || exit 42
+
+SAMHAIN_DB='samhain'
+SAMHAIN_SRV='localhost'
+SAMHAIN_PRT='3306'
+SAMHAIN_USR='samhain'
+SAMHAIN_PWD='*******'
+
+
+mysql -u ${SAMHAIN_USR} --password=${SAMHAIN_PWD} ${SAMHAIN_DB} \
+	-P ${SAMHAIN_PRT} -h ${SAMHAIN_SRV} \
+	-e 'select count(*) from log where log_host="'${1}'";'  || \
+( echo "SELECT FAILED" && exit 42 )
+
+mysql -u ${SAMHAIN_USR} --password=${SAMHAIN_PWD} ${SAMHAIN_DB} \
+	-P ${SAMHAIN_PRT} -h ${SAMHAIN_SRV} \
+	-e 'delete from log where log_host="'${1}'";' || \
+( echo "CLEANUP FAILED" && exit 42 )
+
Index: /trunk/scripts/samhain-scripts/samhain.table.rotate.pl
===================================================================
--- /trunk/scripts/samhain-scripts/samhain.table.rotate.pl	(revision 1)
+++ /trunk/scripts/samhain-scripts/samhain.table.rotate.pl	(revision 1)
@@ -0,0 +1,45 @@
+#!/usr/bin/perl
+#-------------------------------------------------------------------------#
+# Author: Simon Bailey, <simon.bailey@uibk.ac.at>                         #
+#                                                                         #
+# table rotation script for shifting data from the main table to keep     #
+# yule/samhain/beltane happy and fast.                                    #
+# the main reason for this is that we had 62568 log entries after         #
+# less than a week of real work with yule/samhain/beltane                 #
+# this script takes all data which is older than a day and acknowledged   #
+# and inserts it into a backup table, also in the main database.          #
+#-------------------------------------------------------------------------#
+
+use DBI;
+
+# Configuration Variables
+$SAMHAIN_DB='samhain';
+$SAMHAIN_SRV='localhost';
+$SAMHAIN_PRT='3306';
+$SAMHAIN_USR='samhain';
+$SAMHAIN_PWD='*******';
+
+# GMT Offset -- change this to your GMT Offset.
+# CET = +1
+$GMT_OFFSET = 1;
+
+# get the current date in GMT time, then convert it to yesterday
+($sec,$min,$hr,$day,$mon,$year,$wday,$ytag,$isdst) = gmtime(time);
+
+# year is returned as real year - 1900...
+$realYear = ($year-100+2000);
+$realMonth = ($mon+1); # month is a zero base array
+$realHour = ($hr+$GMT_OFFSET);
+$yesterday = ($day-1);
+
+$dbh = DBI->connect("DBI:mysql:database=$SAMHAIN_DB;host=$SAMHAIN_SRV;port=$SAMHAIN_PRT",$SAMHAIN_USR,$SAMHAIN_PWD);
+
+$sth = $dbh->prepare("INSERT INTO log_backup SELECT * FROM log WHERE ((log_ref IS NULL AND entry_status!=\'NEW\') OR (log_ref IS NOT NULL)) AND log_time < \'$realYear-$realMonth-$yesterday $realHour:00:00\';");
+$sth->execute;
+
+# print "insert done";
+
+$sth = $dbh->prepare("DELETE FROM log WHERE ((log_ref IS NULL AND entry_status!=\'NEW\') OR (log_ref IS NOT NULL)) AND log_time < \'$realYear-$realMonth-$yesterday $realHour:00:00\';");
+$sth->execute;
+
+# print "delete done";
Index: /trunk/scripts/samhain.ebuild.in
===================================================================
--- /trunk/scripts/samhain.ebuild.in	(revision 584)
+++ /trunk/scripts/samhain.ebuild.in	(revision 1)
@@ -69,5 +69,5 @@
 	dodoc docs/BUGS COPYING docs/Changelog LICENSE docs/README \
 	      docs/README.UPGRADE docs/sh_mounts.txt docs/sh_userfiles.txt \
-	      docs/MANUAL-2_4.ps docs/MANUAL-2_4.html.tar
+	      docs/MANUAL-2_0.ps docs/MANUAL-2_0.html.tar
 
 	dohtml docs/HOWTO-client+server.html docs/HOWTO-samhain+GnuPG.html \
Index: /trunk/scripts/samhain.spec.in
===================================================================
--- /trunk/scripts/samhain.spec.in	(revision 584)
+++ /trunk/scripts/samhain.spec.in	(revision 1)
@@ -70,5 +70,5 @@
         # Activate boot-time start up
         cd %{_localstatedir}/lib/%{name}
-        /bin/sh ./samhain-install.sh --verbose install-boot
+        ./samhain-install.sh --verbose install-boot
         if test -f /sbin/chkconfig; then
 		/sbin/chkconfig --add samhain
@@ -100,5 +100,5 @@
         cd %{_localstatedir}/lib/samhain
         if [ -f ./samhain-install.sh ]; then
-	    /bin/sh ./samhain-install.sh --verbose uninstall-boot
+	    ./samhain-install.sh --verbose uninstall-boot
 	else
 	    if [ -f /sbin/chkconfig ]; then
@@ -109,4 +109,11 @@
 fi
 
+%postun
+if [ "$1" = 0 ]; then
+        # remove any kernel modules that might have been installed
+        RVER=`uname -r`
+        rm -f /lib/modules/$RVER/samhain*
+fi
+
 
 %files
@@ -114,11 +121,10 @@
 %dir %{_localstatedir}/run
 %dir %{_localstatedir}/log
-%doc docs/BUGS COPYING docs/Changelog 
-%doc LICENSE docs/HOWTO* docs/MANUAL-2_4.* docs/README*
+%doc docs/BUGS COPYING docs/Changelog docs/TODO
+%doc LICENSE docs/HOWTO* docs/MANUAL-2_0.* docs/README*
 %{_localstatedir}/lib/%{name}
 %{_sbindir}/%{name}
 %attr(644,root,root) %{_mandir}/man5/samhain*
 %attr(644,root,root) %{_mandir}/man8/samhain*
-%attr(644,root,root) /etc/logrotate.d/@install_name@
 %config(noreplace) %{_sysconfdir}/samhainrc
 
